if (rcod == 1)
   % run optimization and show results
   hf = gcbf;
   set(hf,'Pointer','watch')
   try
      [config, fname, vnames] = guiepalg;
      clear mex; 
      eval(['[x,stat]=epalg(fname,config',vnames,');'])
   catch exception
      warning(exception.message);
      set(hf,'Pointer','arrow')
   end
   % show results
   set(hf,'Pointer','arrow')
   rcod = 0;
   runcback
elseif (rcod == 2)
   % save data to configuration file
   if (exist('config')) 
      [matfile, newpath] = uiputfile('*.mat', 'Save As');
      if( exist('x') & exist('stat') )
         eval(['save ',newpath,matfile,' config fname vnames x stat']) 
      else
         eval(['save ',newpath,matfile,' config fname vnames']) 
      end
   end
elseif (rcod == 3)
   % load data from mat file and show results 
   [matfile, newpath] = uigetfile('*.mat', 'Load results');
   eval(['load ',newpath,matfile])
   guiepalg(config, fname, vnames);
   % show results
   rcod = 0;
   runcback
elseif (rcod == 0)
   if( exist('x') & exist('stat') )
      % set EPALG axes as current
      ha = findobj(findobj(0,'Tag','guiepalg'),'Type','axes');
      axes(ha(1))
      plot([1:size(stat,1)], stat(:,2), [1:size(stat,1)],stat(:,3))
      xlabel('generation')
      ylabel('function value')
      fbest = 0;
      if ( ~isempty(fname) )
         eval(['fbest = ',fname,'(x',vnames,');'])
      end
      axes(ha(1))
      ap = axis;
      ht = text(ap(1)+0.5*(ap(2)-ap(1)), ap(3)+0.5*(ap(4)-ap(3)), ['fbest = ',num2str(fbest)]);
   end
end
