function f = sumsq(x, dtype, nbits)

x=x(:); % make a column vector

if(dtype==3) %real coding 
    %nothing to do - values are already in the range -1 to 1
elseif(dtype==2) %integer coding calculate values to be -1 to 1 range
    x = (x-((2^nbits-1)+0)/2)/((2^nbits-1)/2);  
elseif(dtype==1) % bit data type - calculate values to be -1 to 1 range 
    xb = zeros(nbits,length(x)/nbits); 
    xb(1:length(x)) = x(1:length(x)); % now each column is one gene
    base = 2..^([0:nbits-1]); % base for each bit 
    x = base*xb;
    x = (x-((2^nbits-1)+0)/2)/((2^nbits-1)/2);
end

x = x/2 + 0.5; % transform x to be in 0.0 to 1.0 range

f = sum(x.^2);
