function f = sumsq1( x )

x = x(:); % make a column vector
nbits = 7;   % the number of bits is 7
ngen = 10; % the number of genes is 10
base = 2..^([0:nbits-1]); % base for each bit 
xm = zeros(nbits, ngen); % create the matrix so that the each column will be one gene
xm(1:nbits*ngen) = x; % fill the matrix with 0 & 1 values from the coded solution
xv = base*xm;  % matrix multiplication gives integer values in the range: 0 to (2^nbits)-1
xv = xv/(2..^nbits-1); % scale x in order to put it in the required 0.0 - 1.0 range
f = sum(xv.^2); % calculate objective function
